#!/usr/bin/python3
# -*- coding: iso-8859-1 -*-

import asyncio
from aiohttp import web
import socketio
import random
import json
import asyncpg
import onibus
import math
from geopy import distance
import time
import logging

logging.basicConfig(level=logging.DEBUG)

rooms=[]
busesList=[
{'id':1,'nome':'Teste piloto','lat':0.0,'lon':0.0}
]
pontos=[
{'id':1,'nome':'Ponto de nibus interno ucsal','lat':-12.947748, 'lon':-38.413177},
{'id':2,'nome':'Prdio da ps graduao','lat':-12.948547, 'lon':-38.413582},
{'id':3,'nome':'FABLAB','lat':-12.949123, 'lon':-38.413670}
]
usuarios=['']

sio = socketio.AsyncServer(async_mode='aiohttp',port=8081)
app = web.Application()
sio.attach(app)

async def updateBusPosition(request):
   bd={'lat':'','lon':''}
   if(request.rel_url.query.get('lat')!=None)&(request.rel_url.query.get('lon')!=None):
    try:
     bd = {'id':1, 'lat':float(request.rel_url.query['lat']),'lon':float(request.rel_url.query['lon'])}
    except:
     print(request.rel_url.query)
     bd=bd
   if(bd['lat'].__class__==float().__class__)&(bd['lon'].__class__==float().__class__):
    print(time.asctime()+" - "+str(bd))
    rs=''
    busesList[0]={'id':1,'nome':'Teste piloto','lat':bd['lat'],'lon':bd['lon']}
    await sio.emit('monitora',busesList[0],namespace='/monitora')
    for p in pontos:
     print("Dist. at "+p['nome']+": "+str(distance.distance((bd['lat'],bd['lon']),(p['lat'],p['lon'])).meters.__format__('.2f'))+" m")
     if distance.distance((bd['lat'],bd['lon']),(p['lat'],p['lon'])).meters<50.0:
      for u in usuarios:
       if u.__class__=={}.__class__:
        print("Dist. Usu "+str(u['id'])+": "+str(distance.distance((bd['lat'],bd['lon']),(u['lat'],u['lon'])).meters.__format__('.2f'))+" m")
        if distance.distance((bd['lat'],bd['lon']),(u['lat'],u['lon'])).meters<=100.0:
         rs=rs+'pessoa,'
    return web.Response(status=200, body=json.JSONEncoder().encode({'body':rs}), content_type='application/json')
   else:
    return web.Response(status=500, body='Erro', content_type='application/json')

async def updateposition(request):
    bd=await request.json()
    print(time.asctime()+" - "+str(bd))
    rs=''
    busesList[0]={'id':1,'nome':'Teste piloto','lat':bd['lat'],'lon':bd['lon']}
    await sio.emit('monitora',busesList[0],namespace='/monitora')
    for p in pontos:
     #print(distancia(bd['lat'],p['lat'],bd['lon'],p['lon'])*1000.0)
     print("Dist. at "+p['nome']+": "+str(distance.distance((bd['lat'],bd['lon']),(p['lat'],p['lon'])).meters.__format__('.2f'))+" m")
     #if distancia(bd['lat'],p['lat'],bd['lon'],p['lon'])<0.1:
     if distance.distance((bd['lat'],bd['lon']),(p['lat'],p['lon'])).meters<50.0:
      for u in usuarios:
       #print('U'+distancia(bd['lat'],u['lat'],bd['lon'],u['lon'])*1000.0)
       if u.__class__=={}.__class__:
        print("Dist. Usu "+str(u['id'])+": "+str(distance.distance((bd['lat'],bd['lon']),(u['lat'],u['lon'])).meters.__format__('.2f'))+" m")
       #if distancia(bd['lat'],u['lat'],bd['lon'],u['lon'])<0.1:
        if distance.distance((bd['lat'],bd['lon']),(u['lat'],u['lon'])).meters<=100.0:
         rs=rs+'pessoa,'
    return web.Response(status=200, body=json.JSONEncoder().encode({'body':rs}), content_type='application/json')

def distancia(lat1,lat2,lon1,lon2):
    p = 0.017453292519943295
    c = math.cos
    a = 0.5 - c((lat1-lat2) * p) / 2 + c(lat2 * p) *c((lat1) * p) * (1 - c(((lon1- lon2) * p))) / 2
    dis = (12742 * math.asin(math.sqrt(a)))
    return dis

async def index(request):
    with open('index.html') as f:
        return web.Response(text=f.read(), content_type='text/html')

async def buses(request):
        return web.Response(status=200,
body=json.JSONEncoder().encode({'bus':[
{'id':1,'nome':'nibus 1','desc':'Linha 1'},
{'id':2,'nome':'nibus 2','desc':'Linha 2'},
{'id':3,'nome':'nibus 3','desc':'Linha 3'},
{'id':4,'nome':'nibus 4','desc':'Linha 4'},
{'id':5,'nome':'nibus 5','desc':'Linha 5'},
{'id':6,'nome':'nibus 6','desc':'Linha 6'}
]}),
content_type='application/json',
headers={'Access-Control-Allow-Origin':'*'})

@sio.on('connect', namespace='/monitora')
async def connect(sid, environ):
    print(time.asctime()+": connect ", sid)
    await sio.emit(event='monitora',data={'data':'Bem vindo!'},room=sid,namespace='/monitora')
    await sio.emit('monitora',{'data':'+1 conectado'},namespace='/monitora')

@sio.on('query', namespace='/monitora')
async def message(sid, data):
    usuarios[0]={'id':1,'lat':data['action']['lat'],'lon':data['action']['lon']}
    print(usuarios)
    await sio.emit(event='monitora',data={'data':'Monitorando'}, namespace='/monitora')

async def message(sid, data):
    print("message ", data)
    if(data.__class__=={}.__class__)&(data['action'].__class__==[].__class__):
     for tmp in data['action']:
      if tmp[0:3]=='E_r':
       sio.enter_room(sid=sid, room=tmp[2:len(tmp)], namespace='/chat')
       await sio.emit(room=sid,event='chat',data={'data':'Monitorando'}, namespace='/chat')
       await sio.emit(room=tmp[2:len(tmp)], event='chat',data={'data':'Monitorando!'}, namespace='/chat')
      elif tmp[0:3]=='L_r':
       sio.leave_room(sid, tmp[2:len(tmp)], '/chat')
       await sio.emit(room=sid,event='chat',data={'data':'Deixando de monitorar'}, namespace='/chat')
    else:
     await sio.emit(event='chat',data={'data':data}, namespace='/chat')

@sio.on('disconnect', namespace='/monitora')
def disconnect(sid):
    print('disconnect ', sid)

async def simBus():
    while True:
     bs=random.randint(0,5)
     busesList[bs].pos_z=busesList[bs].pos_z+1
     if busesList[bs].pos_z>50:
      busesList[bs].pos_z=-50
     await sio.sleep(1.5)
#     print(bs)
    print("Fim")

async def updBus():
    while True:
     for br in rooms:
      await sio.emit(event='chat',data={'data':busesList[int(br[1:len(br)])-1].pos_z}, namespace='/chat',room=br)
     await sio.sleep(1.5)

app.router.add_get('/', index)
app.router.add_get('/buses', buses)
app.router.add_post('/updpos', updateposition)
app.router.add_get('/updbuspos', updateBusPosition)

if __name__ == '__main__':
#    sio.start_background_task(simBus)
#    sio.start_background_task(updBus)
    web.run_app(app,port=8081)

    # fazer uma pesquisa por origem / destino para listar os nibus
    # exibir no app dados como distncia, localizao, tempo estimado
    # no dispositivo do nibus, incluir luzes para indicar se algum deseja acessar aquele nibus
