#include <SoftwareSerial.h> //biblioteca para emular o TX e o RX
#include <TinyGPS.h> //biblioteca do GPS
#include <Wire.h>
#include <SFE_MMA8452Q.h>

TinyGPS gps1;
SoftwareSerial serial1(10, 11); // RX, TX

MMA8452Q acelerometro(0x1C);

byte pl;
unsigned x, y, z;
bool recebido;
bool modo=false;
 float velocidade;
  float latitude, longitude;
 unsigned long idade;
long tempo;

void setup() {
  Serial.begin(9600); // Velocidade do serial
pinMode(31,INPUT);
 Serial.println("Iniciando acelerometro");
 acelerometro.init();
 Serial.println("Acelerometro iniciado");
 
 Serial.println("Iniciando gps...");
 serial1.begin(9600);
 Serial.println("Gps iniciado");

 Serial.println("Iniciando gsm");
 Serial3.begin(9600);
 
tone(23,40,1);
while(true){
sendAt("at");
//sendAt("ATZ");
sendAt("at+cmee=2");
sendAt("at+cmee?");
sendAt("at+cfun=0");
sendAt("at+cfun=1");
sendAt("at+csq");
sendAt("at+cbc");
sendAt("at+sapbr=0,1");
sendAt("at+cstt=\"zap.vivo.com.br\",\"\",\"\"");
//sendAt("AT+CIICR");
sendAt("AT+SAPBR=3,1,\"Contype\",\"GPRS\"");
sendAt("at+sapbr=3,1,\"apn\",\"zap.vivo.com.br\"");
sendAt("at+sapbr=1,1");
sendAt("at+sapbr=2,1");
sendAt("at+httpterm");
sendAt("AT+HTTPINIT");
sendAt("AT+HTTPPARA=\"CID\",1");
//sendAt("AT+HTTPPARA=\"URL\",\"35.247.234.8:8081/updpos\"");
//sendAt("AT+HTTPPARA=\"CONTENT\",\"application/json\"");
  break;
}
delay(1);
Serial.println("Gsm Iniciado");
 tone(29,8800,100);
 Serial.println("Fim");
 tempo=millis();
}

void sendAt(String cmd){
Serial3.println(cmd);
String rsp="";
int cont=millis();
while(true){
rsp=Serial3.readString();
rsp.trim();
if(rsp.indexOf("OK")>=0){
  tone(29,2400,50);
break;
}else if(rsp.indexOf("ERR")>=0){
  tone(23,1200,50);
  break;
  }else if(rsp.indexOf("{")>=0){
    tone(29,2400,50);
  break;
    }else if(rsp.indexOf("DOWN")>=0){
      tone(29,2400,50);
  break;
}
delay(1);
}
//if(rsp.indexOf("{")>=0){
//Serial.println(rsp.indexOf("BODY"));
//Serial.println(rsp.substring(rsp.lastIndexOf(":\"")));
Serial.println(rsp);
return;
}

void loop() {
  if(modo==true||modo==false){
    String Arsp=Serial.readString();
        if(Arsp.substring(0,4)=="tone") {
      Serial.println(Arsp.substring(0,4));
      Serial.println(Arsp.substring(4,6).toInt());
      Serial.println(Arsp.substring(6).toInt());
      tone(Arsp.substring(4,6).toInt(),Arsp.substring(6).toInt(),250);
        }else if(Arsp.substring(0,4)=="gprs"){
              Serial.println(Arsp.substring(4));
    Serial3.println(Arsp.substring(4));
        }else if(Arsp.substring(0,4)=="gpss"){
          //serial1.println("$PUBX,40,GLL,0,0,0,0*5C");
          gpsLoop1();
        }else if(Arsp.substring(0,4)=="aclr"){
          acelerometroLoop();
          }else if(Arsp.substring(0,4)=="post"){
            sendData();
          }else if(Arsp.substring(0,4)=="dgrd"){
            Serial.println(digitalRead(Arsp.substring (4,6).toInt()));
            }else if(Arsp.substring(0,4)=="modo"){
                noTone(29);
                modo=!modo;
                tone(29,8000,100);
                Serial.println(modo);
              }
            }
  
  /*if(serial1.available()){
    //Serial.println("s1");
    //Serial.println(serial1.readString());
  }else{
    noTone(29);
    tone(29,4444,25);
  }*/
  /*if(Serial3.available()){
    //Serial.println("s3");
//    Serial.println(Serial3.readString());
  }else{
    //noTone(29);
    //tone(29,8888,25);
  }*/
  
 gps1.f_get_position(&latitude, &longitude, &idade);
velocidade = gps1.f_speed_kmph();
acelerometro.read();
byte pl1 = acelerometro.readPL();
x=acelerometro.cx;
y=acelerometro.cy;
z=acelerometro.cz;

  if(gps1.satellites()!=255){
    if(z>=0||y>=0||x>=0){
      if((millis()-tempo)>7000){
sendData();
tempo=millis();
      }
    }
  }else{
    noTone(29);
    tone(29,440,500);
  }
  smartdelay(1000);
}

void sendData(){
  noTone(29);
tone(29,4000,230);
//String data="{\"lat\":"+String(latitude,10)+",\"lon\":"+String(longitude,10)+"}";
String data="lat="+String(latitude,10)+"&lon="+String(longitude,10)+"";
sendAt("AT+HTTPPARA=\"URL\",\"35.247.234.8:8081/updbuspos?"+data+"\"");
//sendAt("at+httpdata=0");
//String tmp="AT+HTTPDATA="+String(data.length()+1)+",1500";
//sendAt(tmp);
//sendAt(data);
sendAt("AT+HTTPACTION=0");
delay(500);
sendAt("AT+HTTPREAD");
noTone(29);
tone(29,2000,230);
return;
}

void gpsLoop1(){
//if(gps1.satellites()!=255){
Serial.print(latitude,10);
Serial.print(", ");
Serial.print(longitude,10);
Serial.println("");
Serial.print(velocidade);
Serial.print(", ");
Serial.print(gps1.satellites());
Serial.print(", ");
Serial.println(gps1.hdop());
}

static void print_float(float val, float invalid, int len, int prec) {
  if (val == invalid) {
    while (len-- > 1)
    Serial.print(' ');
  } else {
    Serial.print(val, prec);
    int vi = abs((int)val);
    int flen = prec + (val < 0.0 ? 2 : 1); // . and -
    flen += vi >= 1000 ? 4 : vi >= 100 ? 3 : vi >= 10 ? 2 : 1;
    for (int i=flen; i<len; ++i)
      Serial.print(' ');
  }
  smartdelay(0);
}

static void smartdelay(unsigned long ms){
  unsigned long start = millis();
  do 
  {
    while (serial1.available())
      gps1.encode(serial1.read());
  } while (millis() - start < ms);
}

void acelerometroLoop(){
  if (acelerometro.available()){
acelerometro.read();
  byte pl1 = acelerometro.readPL();
  if(pl1!=pl){
    pl=pl1;
  switch (pl){
  case PORTRAIT_U:
    Serial.println("Retrato Para Cima");
    break;
  case PORTRAIT_D:
    Serial.println("Retrato Para Baixo");
    break;
  case LANDSCAPE_R:
    Serial.println("Paisagem Direita");
    break;
  case LANDSCAPE_L:
    Serial.println("Paisagem Esquerda");
    break;
  case LOCKOUT:
    Serial.println("Plano");
    break;
  }
  }
  String dados=(String) acelerometro.cx;
  dados.concat("\t");
  dados.concat((String) acelerometro.cy);
  dados.concat("\t");
  dados.concat((String)acelerometro.cz);
  Serial.println(dados);
//  
//  Serial.println("Velocidade: x, y, z");
//  Serial.println(acelerometro.x, 3);
//  Serial.print(", ");
//  Serial.print(acelerometro.y, 3);
//  Serial.print(", ");
//  Serial.println(acelerometro.z, 3);
  }
}

void gpsLoop(){
if (recebido) {
  Serial.println("Ok!");
 Serial.println("----------------------------------------");
 //Latitude e Longitude
 long latitude, longitude;
 unsigned long idadeInfo;
 gps1.get_position(&latitude, &longitude, &idadeInfo); // obtem a latitude, longitude e a idade da informação
// se a latitude for algo valido ela será impressa
 if (latitude != TinyGPS::GPS_INVALID_F_ANGLE) {
 Serial.print("Latitude: ");
 Serial.println(float(latitude) / 100000, 6);
 }
// se a longitude for algo valido ela será impressa
 if (longitude != TinyGPS::GPS_INVALID_F_ANGLE) {
 Serial.print("Longitude: ");
 Serial.println(float(longitude) / 100000, 6);
 }
 // se a data da informação for algo valido ela será impressa
 if (idadeInfo != TinyGPS::GPS_INVALID_AGE) {
 Serial.print("Idade da Informacao (ms): ");
 Serial.println(idadeInfo);
 }
 //Obtem o Dia e Hora no GMT, ou seja, há 3 horas de diferença com o horário do Brasil
 int ano;
 byte mes, dia, hora, minuto, segundo, centesimo;
 gps1.crack_datetime(&ano, &mes, &dia, &hora, &minuto, &segundo, &centesimo, &idadeInfo); //obtendo a data, horário e a idade da informação
 // imprimindo os dados
 Serial.print("Data (GMT): ");
 Serial.print(dia);
 Serial.print("/");
 Serial.print(mes);
 Serial.print("/");
 Serial.println(ano);
Serial.print("Horario (GMT): ");
 Serial.print(hora);
 Serial.print(":");
 Serial.print(minuto);
 Serial.print(":");
 Serial.print(segundo);
 Serial.print(":");
 Serial.println(centesimo);
 //Obtendo a altitude
 float altitudeGPS;
 altitudeGPS = gps1.f_altitude();
// se a altitude for algo valido e diferente de 1000000Cm ela será impressa
 if ((altitudeGPS != TinyGPS::GPS_INVALID_ALTITUDE) && (altitudeGPS != 1000000)) {
 Serial.print("Altitude (cm): ");
 Serial.println(altitudeGPS);
 }
 //obtem a velocidade de locomoção do gps em km/h
 float velocidade;
 velocidade = gps1.f_speed_kmph();
Serial.print("Velocidade (km/h): ");
 Serial.println(velocidade, 2); //Conversão de Nós para Km/h
//obtem o sentito do movimento em centesima de graus
 unsigned long sentido;
 sentido = gps1.course();
Serial.print("Sentido (grau): ");
 Serial.println(float(sentido) / 100, 2);
 //obtem a quantidade de satelites e a precisão
 unsigned short satelites;
 unsigned long precisao;
 satelites = gps1.satellites();
 precisao = gps1.hdop();
if (satelites != TinyGPS::GPS_INVALID_SATELLITES) {
 Serial.print("Satelites: ");
 Serial.println(satelites);
 }
if (precisao != TinyGPS::GPS_INVALID_HDOP) {
 Serial.print("Precisao (centesimos de segundo): ");
 Serial.println(precisao);
 }
 }
 delay(1);
}
