import { BrowserModule } from '@angular/platform-browser';
import { ErrorHandler, NgModule } from '@angular/core';
import { IonicApp, IonicErrorHandler, IonicModule } from 'ionic-angular';
import { SplashScreen } from '@ionic-native/splash-screen';
import { StatusBar } from '@ionic-native/status-bar';

import { MyApp } from './app.component';
import { HomePage } from '../pages/home/home';
import { SearchPage } from '../pages/search/search.page';

import { SocketIoModule, SocketIoConfig } from 'ng-socket-io';

import { HttpClientModule } from '@angular/common/http';
import { HttpModule } from '@angular/http';
import { Geolocation } from '@ionic-native/geolocation';
import { Vibration } from '@ionic-native/vibration';
import { NativeGeocoder } from '@ionic-native/native-geocoder';
import { NativeAudio } from '@ionic-native/native-audio';
import { Insomnia } from '@ionic-native/insomnia';
import { DeviceMotion, DeviceMotionAccelerationData } from '@ionic-native/device-motion';
import { DataService } from '../pages/services/data.service';
import { UpdateService } from '../pages/services/update.service';

const config: SocketIoConfig = { url: 'http://35.247.234.8:8081/monitora', options: {}};

@NgModule({
  declarations: [
    MyApp,
    HomePage,
    SearchPage
  ],
  imports: [
    BrowserModule,
    SocketIoModule.forRoot(config),
    HttpClientModule,
    HttpModule,
    IonicModule.forRoot(MyApp)
  ],
  bootstrap: [IonicApp],
  entryComponents: [
    MyApp,
    HomePage,
    SearchPage
  ],
  providers: [
    StatusBar,
    SplashScreen,
        Geolocation,
    NativeGeocoder,
    NativeAudio,
    Vibration,
    DataService,
    UpdateService,
Insomnia,
DeviceMotion,
    {provide: ErrorHandler, useClass: IonicErrorHandler}
  ]
})
export class AppModule {}
