import { Component, OnInit, ViewChildren, ViewChild } from '@angular/core';
//import { Router } from '@angular/router';
import { UpdateService } from '../services/update.service';
import { DataService } from '../services/data.service';
import { Http ,Response ,Headers, RequestOptions} from '@angular/http';
import { map } from 'rxjs/operators';
import { Geolocation } from '@ionic-native/geolocation';
import { NativeGeocoder, NativeGeocoderOptions, NativeGeocoderReverseResult } from '@ionic-native/native-geocoder';
import { Vibration } from '@ionic-native/vibration';
import { NativeAudio } from '@ionic-native/native-audio';
import { NavController, NavParams } from 'ionic-angular';
import { AlertController } from 'ionic-angular';
import { SearchPage } from '../search/search.page';
import { DeviceMotion, DeviceMotionAccelerationData } from '@ionic-native/device-motion';

@Component({
  selector: 'page-home',
  templateUrl: 'home.html',
})
export class HomePage {

public saudacao: any;
public listadeonibus:any=[];
public listamonitorando:any=[];
public checkmonitorando: any=[];
public watchLocationUpdates:any;
public watch: any;
public watchmot: any;
public loading:any;
public isWatching:boolean;
public geoencoderOptions: NativeGeocoderOptions = {
useLocale: true,
maxResults: 5
};
public context:any;
public os:any;
public gain: any;
public tocando:any;
public audio: any;

constructor(public navCtrl: NavController, public navparams: NavParams, public ds: DataService, private us: UpdateService, private http: Http, private geolocation: Geolocation, private nativeGeocoder: NativeGeocoder, private vibration: Vibration, public alertCtrl: AlertController, private nativeAudio: NativeAudio, public deviceMotion: DeviceMotion){
this.vibration.vibrate([500,100,400]);
try{
this.context = new AudioContext();
  this.os=this.context.createOscillator();
  this.os.frequency.value=840;
  this.gain=this.context.createGain();
  this.os.connect(this.gain);
  this.gain.gain.value = 0.3;
  this.gain.connect(this.context.destination);
  }
  catch(e) {
    //alert('Erro ao iniciar audio neste dispositivo');
  }
this.http.get('http://35.247.234.8:8082/api/index').subscribe(res=>{
if(res.status!=200){
alert("Desculpe, ocorreu um erro na conexão! Tente novamente mais tarde...");
}
},(er)=>alert("Desculpe, ocorreu um erro na conexão. Erro: "+er));
if(new Date().getHours()<12){
this.saudacao="Bom dia!";
}else if(new Date().getHours()<=18){
this.saudacao="Boa tarde!";
}else{
this.saudacao="Boa noite!";
}
//alert(this.saudacao);
this.getGeolocation();
this.deviceMotion.getCurrentAcceleration().then(
(acceleration: DeviceMotionAccelerationData) => this.ds.data['acl']=acceleration,
(error: any) => console.log(error)
);
this.watch = this.geolocation.watchPosition();
this.watchmot = this.deviceMotion.watchAcceleration();
this.watchmot.subscribe((acceleration: DeviceMotionAccelerationData) => {
if(this.ds.data['acl']['x']!=acceleration['x']||this.ds.data['acl']['y']!=acceleration['y']||this.ds.data['acl']['z']!=acceleration['z']){
this.ds.data['acl']=acceleration;
}
},(er)=>alert(er));
this.watch.subscribe((data) => {
if(Math.abs(this.ds.data['acl']['x'])>=2.0||Math.abs(this.ds.data['acl']['y'])>=2.0||Math.abs(this.ds.data['acl']['z'])>=2.0){
if(this.ds.data['latitude']!=data.coords.latitude&&this.ds.data['longitude']!=data.coords.longitude){
this.ds.data['latitude']=data.coords.latitude;
this.ds.data['longitude']=data.coords.longitude;
this.ds.data['accuracy']=data.coords.accuracy;
this.http.post('http://35.247.234.8:8082/api/findPontos',{"tipo":"coordenadas","lat":this.ds.data['latitude'],"lon":this.ds.data['longitude']}).subscribe(res=>{
if(res.json()['status']==200){
this.ds.data['pontoproximo']=res.json()['results'][0];
}
},(er)=>alert("Desculpe, ocorreu um erro na conexão. Erro: "+er));
this.sendData({'lat':data.coords.latitude,'lon':data.coords.longitude});
}
}
});
for(let i=0;i<10;i++){
this.nativeAudio.preloadComplex('audio'+(i+1), 'assets/audio/t'+(i+1)+'.wav',1.0,1,0).then(()=>console.log("l1"), (er)=>alert(er));
}
}

searchPontos(){
alert("Procurar por pontos!");
}
getPontoInfo(){
if(this.ds.data['pontoproximo']['endereco']){
  this.http.post("http://35.247.234.8:8082/api/getEnderecoByPonto",{'id_endereco':this.ds.data['pontoproximo']['endereco']['id']}).subscribe(res=>{
  if(res.json()['status']==200){
  this.showAlert(res);
}
},(er)=>alert("Desculpe, ocorreu um erro na conexão. Erro: "+er));
}
}
async showAlert(res:any){
    const alert = await this.alertCtrl.create({
      title: 'Informações',
      subTitle: this.ds.data['pontoproximo']['nome'],
      message: res.json()['results'][0]['descricao']+'; '+res.json()['results'][0]['rua']+'; '+res.json()['results'][0]['bairro']+'; '+res.json()['results'][0]['cidade']+'.',
      buttons: ['OK']
    });
    await alert.present();
}

isInMonit(obj){
let ind=this.listamonitorando.findIndex(i=>i['id']===obj['id']);
if(ind>=0){
return true;
}else{
return false;
}
}

toggleMonitora(obj){
let i1=this.listadeonibus.findIndex(i=>i['id']===obj['id']);
let i2=this.listamonitorando.findIndex(i=>i['id']===obj['id']);
if(i1>=0&&i2<0){
this.listamonitorando.push(obj);
this.checkmonitorando[obj['id']+'']=true;
}else{
this.listamonitorando.splice(i2);
this.checkmonitorando[obj['id']+'']=false;
for(let i=0;i<10;i++){
this.nativeAudio.stop('audio'+(i+1));
}
}
}

  ngOnInit(){
    this.us.receiveData('monitora').subscribe(message => {
    let _this1=this;
    if(message['id']){
    let i=_this1.listadeonibus.findIndex(i=>i['id']===message['id']);
    if(i>=0){
    _this1.listadeonibus[i]=message;
    }else{
    _this1.listadeonibus.push(message);
    }
i=_this1.listamonitorando.findIndex(i=>i['id']===message['id']);
    if(i>=0){
    _this1.listamonitorando[i]=message;
    _this1.checkmonitorando[message['id']+'']=false;
    }
}

if(_this1.listamonitorando.length>0){
_this1.listamonitorando.forEach(item=>{
let d=_this1.ds.distance(_this1.ds.data['latitude'],item['lat'],_this1.ds.data['longitude'],item['lon']);
let m:Number=300.0;
//alert(d);
console.log(d);
if(d>=0&&d<=m){
let t=10;
//alert(d);
if(d<5.0){
t=1;
}else if(d<10.0){
t=2;
}else if(d<20.0){
t=3;
}else if(d<30.0){
t=4;
}else if(d<40.0){
t=5;
}else if(d<70.0){
t=6;
}else if(d<210.0){
t=7;
}else if(d<240.0){
t=8;
}else if(d<270.0){
t=9;
}else if(d<300.0){
t=10;
}
//alert(t);
this.alertaSonoro(t);
}else{
this.alertaSonoro(-1);
}
});
}

    });
    }

alertaSonoro(tempo){
/*clearInterval(this.tocando);
this.tocando=setInterval(()=>{
  this.os=this.context.createOscillator();
  this.os.frequency.value=840;
  this.gain=this.context.createGain();
  this.os.connect(this.gain);
  this.gain.gain.value = 0.15;
  this.gain.connect(this.context.destination);
  this.os.start(this.context.currentTime);
  this.os.stop(this.context.currentTime+0.10);
},tempo);*/
if(tempo==-1){
for(let i=0;i<10;i++){
this.nativeAudio.stop('audio'+(i+1)).then(()=>console.log("stop "+(i+1)),(er)=>console.log(er));
this.vibration.vibrate(0);
this.tocando=false;
}
}else{
if(!this.tocando){
this.vibration.vibrate([tempo*20,tempo*80]);
this.nativeAudio.play('audio'+tempo).then(()=>{
this.nativeAudio.play('audio'+tempo);
this.vibration.vibrate([tempo*20,tempo*80]);
}, (er)=>console.log(er));
this.tocando=true;
console.log('t'+tempo);
}else{
for(let j=0;j<10;j++){
this.nativeAudio.stop('audio'+(j+1)).then(()=>console.log("stop "+(j+1)),(er)=>console.log(er));
}
this.vibration.vibrate([tempo*20,tempo*80]);
this.nativeAudio.play('audio'+tempo).then(()=>{
console.log('loop'+tempo);
this.nativeAudio.play('audio'+tempo);
this.vibration.vibrate([tempo*20,tempo*80]);
}, (er)=>console.log(er));
this.tocando=true;
console.log('t'+tempo);
}
}
}

/*    addBus(data){
    if(this.busesmonit.indexOf(data)===-1){
    this.busesmonit.push(data);
    }else{
    this.busesmonit.splice(this.busesmonit.indexOf(data),1);
    }
    }*/
    
    sendData(data){
    this.us.sendData('query',{'action':data});
    }
    
      /*sendmsg(){
    this.inmsgs.push(this.outmsg);
    this.us.sendData('chat',this.outmsg);
    this.outmsg = '';
  }*/

    getGeolocation(){
      this.geolocation.getCurrentPosition({'enableHighAccuracy':true}).then((resp) => {
        this.ds.data['latitude'] = resp.coords.latitude;
        this.ds.data['longitude'] = resp.coords.longitude; 
        this.ds.data['accuracy'] = resp.coords.accuracy;
        this.getGeoencoder(this.ds.data['latitude'],this.ds.data['longitude']);
       }).catch((error) => {
         alert('Erro ao tentar obter a localização atual.');
       });
    }
  
    getGeoencoder(latitude, longitude){
      this.nativeGeocoder.reverseGeocode(latitude, longitude, this.geoencoderOptions)
      .then((result: NativeGeocoderReverseResult[]) => {
let r=result[0];
        this.ds.data['endereco']=r['subThoroughfare']+", "+r['thoroughfare']+"; "+r['subLocality']+", "+r['locality']+"; "+r['subAdministrativeArea']+", "+r['administrativeArea'];
        alert(this.ds.data['endereco']);
      })
      .catch((error: any) => {
        alert('Erro ao tentar obter dados da localização atual. '+error);
      });
    }

    search(){
    //this.router.navigate(['/search']);
    this.navCtrl.push(SearchPage);
    }

}
