import { Component } from '@angular/core';
import { Http ,Response ,Headers, RequestOptions} from '@angular/http';
import { map } from 'rxjs/operators';
import { Geolocation } from '@ionic-native/geolocation';
import { NativeGeocoder, NativeGeocoderOptions, NativeGeocoderReverseResult } from '@ionic-native/native-geocoder';
import { Vibration } from '@ionic-native/vibration';
import { NativeAudio } from '@ionic-native/native-audio';
import { NavController, NavParams } from 'ionic-angular';
import { AlertController } from 'ionic-angular';
import { DeviceMotion, DeviceMotionAccelerationData } from '@ionic-native/device-motion';

@Component({
  selector: 'page-home',
  templateUrl: 'home.html'
})
export class HomePage {
public geoencoderOptions: NativeGeocoderOptions = {
useLocale: true,
maxResults: 5
};
public lat: any;
public lon: any;
public acl: any;
public prox: any=false;
public interval: any;
public watchmot: any;
public watchgeo: any;
public enviando: any=false;

constructor(public navCtrl: NavController, public navparams: NavParams, private http: Http, private geolocation: Geolocation, private nativeGeocoder: NativeGeocoder, private vibration: Vibration, public alertCtrl: AlertController, private nativeAudio: NativeAudio, public deviceMotion: DeviceMotion){

this.nativeAudio.preloadComplex('audio1', 'assets/audio/audio1.wav',1.0,1,0).then(()=>console.log("l1"), (er)=>alert(er));
this.nativeAudio.preloadComplex('t1', 'assets/audio/t1.wav',1.0,1,0).then(()=>console.log("l1"), (er)=>alert(er));

this.deviceMotion.getCurrentAcceleration().then(
(acceleration: DeviceMotionAccelerationData) => this.acl=acceleration,
(error: any) => console.log(error)
);

this.geolocation.getCurrentPosition({'enableHighAccuracy':true}).then(
(resp) => {
this.lat = resp.coords.latitude;
this.lon = resp.coords.longitude;
},
(error: any) => console.log(error)
        );
        
this.watchgeo = this.geolocation.watchPosition();
this.watchmot = this.deviceMotion.watchAcceleration();

this.watchmot.subscribe((acceleration: DeviceMotionAccelerationData) => {
if(this.acl['x']!=acceleration['x']||this.acl['y']!=acceleration['y']||this.acl['z']!=acceleration['z']){
this.acl=acceleration;
}
},(er)=>alert(er));

this.watchgeo.subscribe((data) => {
if(this.lat!=data.coords.latitude&&this.lon!=data.coords.longitude){
this.lat=data.coords.latitude;
this.lon=data.coords.longitude;

if(this.enviando!=false){
this.http.get('http://35.247.234.8:8081/updbuspos?lat='+String(this.lat)+'&lon='+String(this.lon)+'').subscribe(res=>{
if(res.json()['body']!=""){
if(this.prox==false){
this.vibration.vibrate(2500);
this.nativeAudio.play('audio1');
this.prox=true;
this.interval=setTimeout(()=>{
this.prox=false;
this.nativeAudio.play('t1');
}, 10000);
}
}
},(er)=>{
alert("Desculpe, ocorreu um erro na conexão. Erro: "+er);
});
}

}
});

  }

envia(){
this.enviando=!this.enviando;
}
  
}
