package restbus

import grails.converters.JSON
import org.grails.web.json.JSONObject

import javax.crypto.Cipher
import javax.crypto.spec.IvParameterSpec
import javax.crypto.spec.SecretKeySpec

class ApiController {
    static allowedMethods = [index: 'get', listOnibusByPonto: 'post', listPontosByOnibus: 'post', findPontos: 'post', listAllOnibus: 'get', getOnibusGps: 'post']
    def miscService

    def index() {
        [mensagem: 'Bem-vindo(a)! De acordo com a última verificação, tudo está ok!']
    }

    def listOnibusByPonto(){
        def rq=[:]
        def pl
        if(request.JSON.id_ponto){
            def pt=Ponto.findAllById(request.JSON.id_ponto)
            if(pt) {
                pl = Onibus.createCriteria().list {
                    pontos{
                        eq('id',pt[0].id)
                    }
                }
            }
        }
        if(pl) {
            rq.results=pl
            rq.status=200
        }else{
            rq.erro='A pesquisa não encontrou nenhum ônibus...'
            rq.status=404
        }
        println(rq)
        render rq as JSON
    }
    def listAllOnibus(){
        def rq=Onibus.findAll()
        render rq as JSON
    }
    def getEnderecoByPonto(){
        def rq=[:]
        def pl
        if(request.JSON.id_endereco){
            pl=Endereco.findAllById(request.JSON.id_endereco)
        }
        if(pl) {
            rq.results=pl
            rq.status=200
        }else{
            rq.erro='A pesquisa não encontrou nenhum endereço...'
            rq.status=404
        }
        println(rq)
        render rq as JSON
    }
    def listPontosByOnibus(){
        def rq=[:]
        def pl
        if(request.JSON.id_onibus){
                pl = Onibus.createCriteria().listDistinct {
                    pontos {}
                    eq('id',(long)request.JSON.id_onibus)
                }
            pl=pl[0].pontos
        }
        if(pl) {
            rq.results=pl
            rq.status=200
        }else{
            rq.erro='A pesquisa não encontrou nenhum ponto...'
            rq.status=404
        }
        println(rq)
        render rq as JSON
    }
    def findPontos(){
        def rq=[:]
        def pl
        println(request.JSON)
        if(request.JSON.tipo=='coordenadas'&&(request.JSON.lat)&&(request.JSON.lon)){
                def dist = miscService.minMaxCoordenadas(request.JSON.lon, request.JSON.lat, 1.0)
                println(dist.latmin+", "+dist.lonmin+"\n"+dist.latmax+", "+dist.lonmax+"\n"+request.JSON.lat+", "+request.JSON.lon)
                println(miscService.distancia(dist.latmin,dist.latmax,dist.lonmin,dist.lonmax,0,0)/1000)
                println(miscService.distancia(dist.latmin,request.JSON.lat,dist.lonmin,request.JSON.lon,0,0)/1000)
                println(miscService.distancia(dist.latmax,request.JSON.lat,dist.lonmax,request.JSON.lon,0,0)/1000)
                pl = Ponto.findAllByLongitudeBetweenAndLatitudeBetween(dist.lonmin, dist.lonmax, dist.latmin, dist.latmax)
                //def dist1=miscService.minMaxCoordenadas(-12.949317,-38.41029,(double)1)
                //println(dist1)
                //def dist2=[:]
                //dist2.latmin=-12.947968
                //dist2.lonmin=-38.408941
                //dist2.latmax=-12.950666
                //dist2.lonmax=-38.411639
                //println(dist2)
                //println(dist1.latmin+" - "+dist2.latmin)
                //println(dist1.lonmin+" - "+dist2.lonmin)
                //println(dist1.latmax+" - "+dist2.latmax)
                //println(dist1.lonmax+" - "+dist2.lonmax)
                //println(dist)
        } else if(request.JSON.tipo=='nome_ponto'&&(request.JSON.nome_ponto)) {
            pl=Ponto.createCriteria().list {
                    ilike('nome', '%'+request.JSON.nome_ponto+'%')
            }
        } else if(request.JSON.tipo=='rua'&&(request.JSON.nome_rua)){
            pl=Ponto.createCriteria().list {
                endereco {
                    ilike('rua', '%' + request.JSON.nome_rua + '%')
                }
            }
        } else if(request.JSON.tipo=='bairro'&&(request.JSON.nome_bairro)){
            pl=Ponto.createCriteria().list {
                endereco {
                    ilike('bairro', '%' + request.JSON.nome_bairro + '%')
                }
            }
        } else if(request.JSON.tipo=='cep'&&(request.JSON.cep)){
            pl=Ponto.createCriteria().list {
                endereco {
                    ilike('cep', '%' + request.JSON.cep + '%')
                }
            }
        } else if(request.JSON.tipo=='descricao'&&(request.JSON.descricao)){
            pl=Ponto.createCriteria().list {
                endereco {
                    ilike('descricao', '%' + request.JSON.descricao + '%')
                }
            }
        }
        else{
            pl=['erro':'Parâmetro inválido...']
        }
        if(pl) {
            rq.results=pl
            rq.status=200
        }else{
            rq.erro='A pesquisa não encontrou nenhum ponto...'
            rq.status=404
        }
        println(rq)
        render rq as JSON
    }

    def getOnibusGps(){
        def rq=[:]
        def pl
        if(request.JSON.onibus&&request.JSON.ponto) {
            if ((request.JSON.onibus.getClass()==JSONObject && request.JSON.ponto.getClass()==JSONObject)&&(request.JSON.onibus.id&&request.JSON.ponto.id)) {
                if ((Onibus.findById((long) request.JSON.onibus.id)) && (Ponto.findById((long) request.JSON.ponto.id))) {
                    pl = "oid" + request.JSON.ponto.id + "pid" + request.JSON.onibus.id
                    Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding")
                    cipher.init(Cipher.ENCRYPT_MODE, new SecretKeySpec("umasenhadeacesso".bytes, "AES"), new IvParameterSpec("umasenhadeacesso".bytes))
                    pl = cipher.doFinal(pl.bytes)
                    pl = pl.encodeAsBase64()
                } else {
                    pl = ['erro': 'Ocorreu um erro ao tentar obter uma chave de acesso. C3.']
                }
            } else {
                pl = ['erro': 'Ocorreu um erro ao tentar obter uma chave de acesso. C2.']
            }
        }else{
            pl = ['erro': 'Ocorreu um erro ao tentar obter uma chave de acesso. C1.']
        }
        if(pl) {
            rq.results=pl
            rq.status=200
        }else{
            rq.erro='A pesquisa não encontrou nenhum ponto...'
            rq.status=404
        }
        println(rq)
        render rq as JSON
    }

}
//fim