package restbus

import grails.validation.ValidationException
import org.springframework.http.HttpStatus

import static org.springframework.http.HttpStatus.*

class PainelController {

    static allowedMethods = [save: "POST", update: "PUT", delete: "DELETE"]
def miscService

    def index() {
        respond Onibus.list(), model:[onibusCount: Onibus.count()]
    }

    def listaOnibus(){
        def onibus_list=Onibus.createCriteria().list {
            pontos {
                endereco {
                    if(params.cidade) eq('cidade',params.cidade)
                    if(params.bairro) eq('bairro',params.bairro)
                    if(params.rua) eq('rua',params.rua)
                }
            }
        }

    }

    def create_onibus() {
        def linhas=Onibus.createCriteria().listDistinct {projections{property 'linha','nome_linha'}}
        def pontos=Ponto.createCriteria().listDistinct {}
        println(params)
        println(flash.message)
        println(flash.onibus)
        if(!flash.onibus){
            respond(model: [onibus: new Onibus(), linhas: linhas, pontos: pontos], view: 'create_onibus')
        }else{
            respond(model: [onibus: flash.onibus, linhas: linhas, pontos: pontos], view: 'create_onibus')
        }
    }
    def create_ponto(){
        def enderecos=Endereco.createCriteria().listDistinct {}
        respond(model: [ponto: new Ponto(), enderecos: enderecos], view: 'create_ponto')
    }
    def create_endereco(){
        def bairros=[:]
        bairros=miscService.listBairros()
        respond(model: [endereco: new Endereco(), bairros: bairros], view: 'create_endereco')
    }
    def save_endereco(Endereco endereco) {
        if (endereco == null) {
            notFound()
            return
        }
        if(!endereco.save([failOnerror: true, flush: true])){
            respond endereco.errors, view:'create_endereco'
            return
        }
        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.created.message', args: [message(code: 'endereco.label', default: 'Endereo'), endereco.id])
                redirect(action: 'create_endereco')
            }
            '*' { respond endereco, [status: CREATED] }
        }
    }
    def save_ponto(Ponto ponto) {
        if (ponto == null) {
            notFound()
            return
        }
        if(!ponto.save([failOnerror: true, flush: true])){
            respond ponto.errors, view:'create_ponto'
            return
        }
        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.created.message', args: [message(code: 'ponto.label', default: 'Ponto'), ponto.id])
                redirect(action: 'create_ponto')
            }
            '*' { respond ponto, [status: CREATED] }
        }
    }

    def save(Onibus onibus) {
        if (onibus == null) {
            notFound()
            return
        }
            if(onibus.save([failOnerror: true, flush: true])) {
                flash.message='nibus criado com sucesso!'
                flash.onibus=onibus
                redirect(    action: 'create_onibus')
            }else{
                flash.message='Erro ao criar nibus...'
                flash.onibus=onibus
                redirect(action: 'create_onibus')
            }
    }

    def edit(Long id) {
        respond Onibus.get(id)
    }

    def update(Onibus onibus) {
        if (onibus == null) {
            notFound()
            return
        }

        try {
            onibus.save()
        } catch (ValidationException e) {
            respond onibus.errors, view:'edit'
            return
        }

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.updated.message', args: [message(code: 'onibus.label', default: 'Onibus'), onibus.id])
                redirect onibus
            }
            '*'{ respond onibus, [status: OK] }
        }
    }

    def delete(Long id) {
        if (id == null) {
            notFound()
            return
        }

        Onibus.delete(id)

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.deleted.message', args: [message(code: 'onibus.label', default: 'Onibus'), id])
                redirect action:"index", method:"GET"
            }
            '*'{ render status: NO_CONTENT }
        }
    }

    protected void notFound() {
        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.not.found.message', args: [message(code: 'onibus.label', default: 'Onibus'), params.id])
                redirect action: "index", method: "GET"
            }
            '*'{ render status: NOT_FOUND }
        }
    }

}
//fim