package restbus

import grails.gorm.transactions.Transactional

@Transactional
class MiscService {

    def listBairros() {
        return ['Acupe', 'Aeroporto', 'guas Claras', 'Alto da Terezinha', 'Alto das Pombas', 'Alto do Cabrito', 'Alto do Coqueirinho', 'Amaralina', 'Areia Branca', 'Arenoso',
                'Arraial do Retiro', 'Bairro da Paz', 'Baixa de Quintas', 'Barbalho', 'Barra', 'Barreiras', 'Barris', 'Beiru/Tancredo Neves', 'Boa Viagem', 'Boa Vista de Brotas',
                'Boa Vista de So Caetano', 'Boca da Mata', 'Boca do Rio', 'Bom Ju', 'Bonfim', 'Brotas', 'Cabula', 'Cabula VI', 'Caixa D?gua', 'Cajazeiras II',
                'Cajazeiras IV', 'Cajazeiras V', 'Cajazeiras VI', 'Cajazeiras VII', 'Cajazeiras VIII', 'Cajazeiras X', 'Cajazeiras XI', 'Calabar', 'Calabeto', 'Calada',
                'Caminho das rvores', 'Caminho de Areia', 'Campinas de Piraj', 'Canabrava', 'Candeal', 'Canela', 'Capelinha', 'Cassange', 'Castelo Branco', 'Centro',
                'Centro Administrativo da Bahia', 'Centro Histrico', 'Chapada do Rio Vermelho', 'Cidade Nova', 'Comrcio', 'Cosme de Farias', 'Costa Azul', 'Coutos', 'Curuzu', 'Dom Avelar',
                'Doron', 'Engenho Velho da Federao', 'Engenho Velho de Brotas', 'Engomadeira', 'Fazenda Coutos', 'Fazenda Grande do Retiro', 'Fazenda Grande I', 'Fazenda Grande II', 'Fazenda Grande III', 'Fazenda Grande IV',
                'Federao', 'Garcia', 'Graa', 'Granjas Rurais Presidente Vargas', 'IAPI', 'Ilha de Bom Jesus dos Passos', 'Ilha de Mar', 'Ilha dos Frades', 'Imbu', 'Itacaranha',
                'Itaigara', 'Itapu', 'Itinga', 'Jaguaripe I', 'Jardim Armao', 'Jardim Cajazeiras', 'Jardim das Margaridas', 'Jardim Nova Esperana', 'Jardim Santo Incio', 'Lapinha',
                'Liberdade', 'Lobato', 'Luiz Anselmo', 'Macabas', 'Mangueira', 'Marechal Rondon', 'Mares', 'Massaranduba', 'Mata Escura', 'Matatu',
                'Monte Serrat', 'Moradas da Lagoa', 'Mussurunga', 'Narandiba', 'Nazar', 'Nordeste de Amaralina', 'Nova Braslia', 'Nova Constituinte', 'Nova Esperana', 'Nova Sussuarana',
                'Novo Horizonte', 'Novo Marotinho', 'Ondina', 'Palestina', 'Paripe', 'Patamares', 'Pau da Lima', 'Pau Mido', 'Periperi', 'Pernambus',
                'Pero Vaz', 'Piat', 'Piraj', 'Pituau', 'Pituba', 'Plataforma', 'Porto Seco Piraj', 'Praia Grande', 'Resgate', 'Retiro',
                'Ribeira', 'Rio Sena', 'Rio Vermelho', 'Roma', 'Saboeiro', 'Santa Cruz', 'Santa Luzia', 'Santa Mnica', 'Santo Agostinho', 'Santo Antnio',
                'So Caetano', 'So Cristvo', 'So Gonalo', 'So Joo do Cabrito', 'So Marcos', 'So Rafael', 'So Tom', 'Saramandaia', 'Sade', 'Sete de Abril',
                'Stella Maris', 'STIEP', 'Sussuarana', 'Toror', 'Trobogy', 'Uruguai', 'Vale das Pedrinhas', 'Vale dos Lagos', 'Valria', 'Vila Canria',
                'Vila Laura', 'Vila Ruy Barbosa/Jardim Cruzeiro', 'Vitria']
    }

    def distancia(double lat1, double lat2, double lon1, double lon2, double el1, double el2) {
        int R = 6371; // Radius of the earth
        double latDistance = Math.toRadians(lat2 - lat1);
        double lonDistance = Math.toRadians(lon2 - lon1);
        double a = Math.sin(latDistance / 2) * Math.sin(latDistance / 2) + Math.cos(Math.toRadians(lat1)) * Math.cos(Math.toRadians(lat2)) * Math.sin(lonDistance / 2) * Math.sin(lonDistance / 2);
        double c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
        double distance = R * c * 1000; // convert to meters
        double height = el1 - el2;
        distance = Math.pow(distance, 2) + Math.pow(height, 2);
        return Math.sqrt(distance);
    }

    def minMaxCoordenadas(double lon, double lat, double dist){
        double R = 6371;
        double radius = dist;
        double longMin = lon - Math.toDegrees(radius/R/Math.cos(Math.toRadians(lat)));
        double longMax = lon + Math.toDegrees(radius/R/Math.cos(Math.toRadians(lat)));
        double latMax = lat + Math.toDegrees(radius/R);
        double latMin = lat - Math.toDegrees(radius/R);
        def values=[:];
        values.latmin=latMin
        values.latmax=latMax
        values.lonmin=longMin
        values.lonmax=longMax
        return values
    }
}
