<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'ponto.label', default: 'Ponto')}" />
        <title><g:message code="default.create.label" args="[entityName]" /></title>
        <script src='https://api.tiles.mapbox.com/mapbox-gl-js/v0.53.1/mapbox-gl.js'></script>
        <link href='https://api.tiles.mapbox.com/mapbox-gl-js/v0.53.1/mapbox-gl.css' rel='stylesheet' />
    </head>
    <body>
        <a href="#create-ponto" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="create" action="create_endereco">Inserir novo endereço</g:link></li>
                <li><g:link class="create" action="create_ponto">Inserir novo ponto</g:link></li>
                <li><g:link class="create" action="create_onibus">Inserir novo ônibus</g:link></li>
            </ul>
        </div>
        <div id="create-ponto" class="content scaffold-create" role="main">
            <h1><g:message code="default.create.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
            </g:if>
            <g:hasErrors bean="${this.model.ponto}">
            <ul class="errors" role="alert">
                <g:eachError bean="${this.model.ponto}" var="error">
                <li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message error="${error}"/></li>
                </g:eachError>
            </ul>
            </g:hasErrors>
            <g:form method="POST" action="save_ponto" controller="painel">
                <div class="container-fluid"><div class="row">                <div class="col">
                <fieldset class="form">
                    <f:all bean="${this.model.ponto}" except="endereco"/>
                    <f:field property="endereco" bean="${this.model.ponto}" label="Endereço"></f:field>
                </fieldset>
                </div></div>
                    <div class="row" style="height: 300px;"><div class="col">
                        <div id="mapa" style="position:absolute; top:0; bottom:0; width:100%; height: 100;"></div>
                </div></div></div>
                <fieldset class="buttons">
                    <g:submitButton name="create" class="save" value="${message(code: 'default.button.create.label', default: 'Create')}" />
                </fieldset>
            </g:form>
        </div>


<g:javascript>
    mapboxgl.accessToken='pk.eyJ1IjoiY2FybG9zZGNydXoiLCJhIjoiY2p1aWljanNjMWFzYzQ1cDNucXdqYjg5YiJ9.nFYSspNZm3xvpps1bELVQw';
    var bounds = [
        [-74.04728500751165, 40.68392799015035], // Southwest coordinates
        [-73.91058699000139, 40.87764500765852]  // Northeast coordinates
    ];
    var map = new mapboxgl.Map({
        container: 'mapa',
        style: 'mapbox://styles/mapbox/streets-v11',
        center: [-12.9722, -38.5014],
        zoom: 9
    });
    map.on('load', function() {
        map.setLayoutProperty('country-label','text-field',['get', 'name_' + 'pt-br']);
        map.addLayer({
            id: 'terrain-data',
            type: 'line',
            source: {
                type: 'vector',
                url: 'mapbox://mapbox.mapbox-terrain-v2'
            },
            'source-layer': 'contour'
        });
        map.addLayer({
            id: 'rpd_parks',
            type: 'fill',
            source: {
                type: 'vector',
                url: 'mapbox://mapbox.3o7ubwm8'
            },
            'source-layer': 'RPD_Parks'
        });
    });
    map.on('click', function (e) {
        document.getElementById('latitude').setAttribute('value',e.lngLat.lat);
        document.getElementById('longitude').setAttribute('value',e.lngLat.lng);
    });
</g:javascript>
    </body>
</html>